import Base from "../Base";
import Header from "./Header";
import Source from "./Source"

class Column extends Base {

    constructor(name) {
        super()

        this.name = name

        this.initial_width = null

        this.width = null

        this.widthpx = null

        this.order_no = null

        this.header = new Header()

        this.source = new Source()

        this.visible = true

        this.title = null
    }

    SetWidth(value) {
        this.initial_width = value
        this.width = value
        return this
    }

    SetWidthPx(value) {
        this.widthpx = value
        return this
    }

    SetTitle(value) {
        this.title = value
        return this
    }

    SetOrderNumber(value) {
        this.order_no = value
        return this
    }

    SetCaption(value) {
        this.title = value.replace('<br/>', ' ')
        this.header.caption = value
        return this
    }

    SetType(value) {
        this.source.type = value
        return this
    }

    SetRenderer(value) {
        this.source.renderer = value
        return this
    }

    SetCellTitle(value) {
        this.source.title = value
        return this
    }

    SetOrderable(value) {
        this.header.orderable = value
        return this
    }

    SetOnClick(value) {
        this.source.SetOnClick(value)
        return this
    }

    AddHeaderStyle(value) {
        _.each(value, (v, k) => {
            this.header.htmlStyle[k] = v
        })
        return this
    }

    AddSourceStyle(value) {
        _.each(value, (v, k) => {
            this.source.htmlStyle[k] = v
        })
        return this
    }

    SetFilterable(value) {
        this.header.SetFilterable(value)
        return this
    }

    UpdateWidth(side) {
        // alert('UpdateWidth ' + side + '-' + this.name + ' ---> ' + this.order_no)
        this.width = 1 * this.width + 1 * (side == 'left' ? -1 : +1)
    }

    get headerStyle() {
        let r = {}, width = null
        if(! this.widthpx)
        {
            width = this.width + '% !important'
        }
        else
        {
            width = this.widthpx + 'px !important'
        }
        r['width'] = width
        _.each(this.header.htmlStyle, (v, k) => {
            r[k] = v
        })
        return r
    }

    get dataStyle() {
        let r = {}, width = null
        if(! this.widthpx)
        {
            width = this.width + '% !important'
        }
        else
        {
            width = this.widthpx + 'px !important'
        }
        r['width'] = width
        _.each(this.source.htmlStyle, (v, k) => {
            r[k] = v
        })
        return r
    }

    get dataTitle() {
        return this.source.title
    }

    get sourceType() {
        return this.source.type
    }

    get sourceRenderer() {
        return this.source.renderer
    }


}

export default Column